/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.2"
#define KEYPATH     "Software\\Ositis\\WinProxy"
#define BUFFSZ      4096
#define REG_IT(x)   len = BUFFSZ; \
                    if(RegQueryValueEx( \
                      key, \
                      x, \
                      NULL, \
                      NULL, \
                      buff, \
                      (void *)&len)) { \
                        *buff = 0; \
                    }



void winproxy_pwd(char *data);



int main(void) {
    HKEY    key;
    char    buff[BUFFSZ];
    int     len;


    setbuf(stdout, NULL);

    fputs("\n"
        "Winproxy administrator password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KEYPATH, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    REG_IT("Administration Username");
    printf("   Administration Username:   %s\n", buff);

    REG_IT("Administration Password");
    winproxy_pwd(buff);
    printf("   Administration Password:   %s\n", buff);

    RegCloseKey(key);

    fputs("\n  Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void winproxy_pwd(char *data) {
    const static char   encdata[] = "Some of your security settings were not available";
    char                *p;

    p = (char *)encdata;
    while(*data) {
        *data++ ^= (((p[1] << 2) ^ p[0]) + p[2]) & 0x1f;
        if(!p[4]) p = (char *)encdata;
            else p++;
    }
}


